package com.casic.dcms.view.business;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;
import android.view.View;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.Nullable;
import androidx.core.content.ContextCompat;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.ActivityChangeShopBinding;
import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.utils.PictureSelectorHelper;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.callback.ISelectorListener;
import com.casic.dcms.view.BigImageActivity;
import com.casic.dcms.view.map.ArcGISMapActivity;
import com.casic.dcms.vm.ShopViewModel;
import com.casic.dcms.vm.UploadViewModel;
import com.gyf.immersionbar.ImmersionBar;
import com.luck.picture.lib.entity.LocalMedia;
import com.pengxh.androidx.lite.adapter.EditableImageAdapter;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.hub.ContextHub;
import com.pengxh.androidx.lite.hub.IntHub;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.utils.ImmerseStatusBarManager;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class ChangeShopInfoActivity extends AndroidxBaseActivity<ActivityChangeShopBinding> {

    private final Context context = ChangeShopInfoActivity.this;
    private final ArrayList<String> realPaths = new ArrayList<>(); //真实图片路径
    private final List<String> imageList = new ArrayList<>(); //上传到服务器的数据集
    private UploadViewModel uploadViewModel;
    private ShopViewModel shopViewModel;
    private String merchantId;  //商户id
    private String merchantName;
    private EditableImageAdapter imageAdapter;

    //新版onActivityResult
    private final ActivityResultLauncher<Intent> changeShopInfoLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), new ActivityResultCallback<ActivityResult>() {
        @Override
        public void onActivityResult(ActivityResult result) {
            if (result.getResultCode() == Activity.RESULT_OK) {
                Intent data = result.getData();
                if (data == null) {
                    return;
                }
                String community = data.getStringExtra("community");
                merchantName = data.getStringExtra("shopName");
                merchantId = data.getStringExtra("shopID");
                viewBinding.communityNameView.setText(community);
                viewBinding.shopView.setText(merchantName);
                viewBinding.shopView.setTextColor(ContextCompat.getColor(context, R.color.mainTextColor));
            }
        }
    });

    @Override
    protected void setupTopBarLayout() {
        ImmerseStatusBarManager.setColor(this, IntHub.convertColor(this, R.color.white));
        ImmersionBar.with(this).statusBarDarkFont(true).init();

        viewBinding.titleBarLayout.titleView.setText("商铺变更");
        viewBinding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {

    }

    @Override
    protected void initData() {
        uploadViewModel = new ViewModelProvider(this).get(UploadViewModel.class);
        shopViewModel = new ViewModelProvider(this).get(ShopViewModel.class);

        imageAdapter = new EditableImageAdapter(this, 3, 13);
        viewBinding.addImageRecyclerView.setAdapter(imageAdapter);
    }

    @Override
    protected void initEvent() {
        viewBinding.shopLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(context, ArcGISMapActivity.class);
                intent.putExtra("type", "商铺变更");
                changeShopInfoLauncher.launch(intent);
            }
        });

        imageAdapter.setOnItemClickListener(new EditableImageAdapter.OnItemClickListener() {
            @Override
            public void onAddImageClick() {
                PictureSelectorHelper.selectPicture(context, new ISelectorListener() {
                    @Override
                    public void onSuccess(ArrayList<LocalMedia> result) {
                        if (result.size() == 1) {
                            uploadViewModel.uploadImage(new File(result.get(0).getRealPath()));
                        } else {
                            for (LocalMedia localMedia : result) {
                                uploadViewModel.uploadImage(new File(localMedia.getRealPath()));
                            }
                        }
                    }
                });
            }

            @Override
            public void onItemClick(int position) {
                if (realPaths.get(position).isEmpty()) {
                    StringHub.show(context, "图片加载失败，无法查看大图");
                } else {
                    ContextHub.navigatePageTo(context, BigImageActivity.class, position, realPaths);
                }
            }

            @Override
            public void onItemLongClick(@Nullable View view, int position) {
                imageList.remove(position);
                imageAdapter.deleteImage(position);
            }
        });
        uploadViewModel.imageModel.observe(this, new Observer<ActionResultBean>() {
            @Override
            public void onChanged(ActionResultBean resultBean) {
                if (resultBean.getCode() == 200) {
                    if (imageAdapter.getItemCount() <= 3) {
                        String url = resultBean.getData();
                        imageList.add(url);
                        realPaths.add(StringHelper.appendCompleteURL(url));
                        imageAdapter.setupImage(realPaths);
                    } else {
                        StringHub.show(context, "最多只能上传3张图片");
                    }
                }
            }
        });

        viewBinding.submitButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                String phoneNumber = viewBinding.phoneNumberView.getText().toString().trim().replace(" ", "");
                if (TextUtils.isEmpty(phoneNumber)) {
                    StringHub.show(context, "电话号码还未填写");
                    return;
                }
                if (StringHub.isPhoneNumber(phoneNumber)) {
                    String shopLocation = viewBinding.shopLocationView.getText().toString().trim().replace(" ", "");
                    if (TextUtils.isEmpty(shopLocation)) {
                        StringHub.show(context, "店铺地址还未填写");
                        return;
                    }
                    String shopKeeper = viewBinding.shopKeeperView.getText().toString().trim().replace(" ", "");
                    if (TextUtils.isEmpty(shopKeeper)) {
                        StringHub.show(context, "店主名还未填写");
                        return;
                    }
                    shopViewModel.changeShopInfo(merchantId, merchantName, shopKeeper, phoneNumber, StringHelper.reformatURL(imageList)
                    );
                } else {
                    StringHub.show(context, "电话号码格式不对");
                }
            }
        });
        shopViewModel.changeResultModel.observe(this, new Observer<ActionResultBean>() {
            @Override
            public void onChanged(ActionResultBean resultBean) {
                if (resultBean.getCode() == 200) {
                    StringHub.show(context, "提交成功");
                    finish();
                } else {
                    StringHub.show(context, "提交失败，请重试");
                }
            }
        });
    }
}